#pragma once

#define vector_t(type)\
struct {\
    int size;\
    int real_size;\
    type *_;\
}

#define vector_alloc(v, s) {\
    v.size = 0;\
    v.real_size = s;\
    v._ = malloc(s * sizeof(__typeof(v._[0])));\
    if (v._ == NULL) abort();\
}

#define vector_push(v, x) {\
    if (v.size + 1 > v.real_size) {\
        if (v.real_size < 1)\
            v.real_size = 1;\
        else\
            v.real_size <<= 1;\
        v._ = realloc(v._, v.real_size * sizeof(__typeof(x)));\
        if (v._ == NULL) abort();\
    }\
    v._[v.size] = x;\
    v.size++;\
}
